/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.bouncycastlecnextractor;

import java.io.FileInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import org.bouncycastle.asn1.x500.X500Name;
import org.bouncycastle.asn1.x500.style.BCStyle;
import org.bouncycastle.cert.jcajce.JcaX509CertificateHolder;


/**
 *
 * @author omozegieaziegbe
 */
public class BouncyCastleCNExtractor {

    public static X509Certificate loadCertificate(String filePath) throws Exception {
        try (FileInputStream fis = new FileInputStream(filePath)) {
            CertificateFactory cf = CertificateFactory.getInstance("X.509");
            return (X509Certificate) cf.generateCertificate(fis);
        }
    }

    public static String extractCN(X509Certificate certificate) throws Exception {
        X500Name x500Name = new JcaX509CertificateHolder(certificate).getSubject();
        return x500Name.getRDNs(BCStyle.CN)[0].getFirst().getValue().toString();
    }

    public static void main(String[] args) {
        try {
            X509Certificate certificate = loadCertificate("src/main/resources/ca.cer");
            String cn = extractCN(certificate);
            System.out.println("CN: " + cn);
        } catch (Exception e) {
        }
    }
}
