/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.cryptacularcnextractor;

import java.io.FileInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import org.cryptacular.util.CertUtil;


/**
 *
 * @author omozegieaziegbe
 */
public class CryptacularCNExtractor {

    public static X509Certificate loadCertificate(String filePath) throws Exception {
        try (FileInputStream fis = new FileInputStream(filePath)) {
            CertificateFactory cf = CertificateFactory.getInstance("X.509");
            return (X509Certificate) cf.generateCertificate(fis);
        }
    }

    public static String extractCN(X509Certificate certificate) throws Exception {
        String subjectName = CertUtil.subjectCN(certificate);
        return subjectName;
    }

    public static void main(String[] args) {
        try {
            X509Certificate certificate = loadCertificate("src/main/resources/ca.cer");
            String cn = extractCN(certificate);
            System.out.println("CN: " + cn);
        } catch (Exception e) {
        }
    }
}
